var P = require('bluebird');

module.exports = function(platform, options) {
    options = options || {};

    const Model = require('./data-model/model');
    const MockedModel = require('./data-model/mocked-model');

    return function(key, schema, opts = {}) {
        const config = platform.getInjector().resolve('config');
        const DBS = platform.getInjector().resolve('DBS');

        var _resolveDB = P.method(function(name) {
            if(DBS) {
                return DBS.getDB(name);
            }
        });

        var dbPromise = _resolveDB(opts.db || config.db.default_db);

        if(options.testMode) {
            return new MockedModel(key, schema, dbPromise);
        }
        else {
            return new Model(key, schema, dbPromise);
        }

    }
};
